import { typeCheck } from '@jarvis-network/core-utils/dist/base/meta';
import { assertIsAddress as A } from '@jarvis-network/core-utils/dist/eth/address';

import { BurnerTokens, ChainLinkPriceAggregators } from './types/config';

// Reference: https://docs.chain.link/docs/ethereum-addresses/
export const chainlinkAggregators = typeCheck<ChainLinkPriceAggregators>()({
  1: {
    EURUSD: A<1>('0xb49f677943BC038e9857d61E7d053CaA2C1734C1'),
    GBPUSD: A<1>('0x5c0Ab2d9b5a7ed9f470386e82BB36A3613cDd4b5'),
    CHFUSD: A<1>('0x449d117117838fFA61263B61dA6301AA2a88B13A'),
    XAUUSD: A<1>('0x214eD9Da11D2fbe465a6fc601a91E62EbEc1a0D6'),
    ETHUSD: A<1>('0x5f4eC3Df9cbd43714FE2740f5E3616155c5b8419'),
    CADUSD: A<1>('0xa34317DB73e77d453b1B8d04550c44D10e981C8e'),
    JPYUSD: A<1>('0xBcE206caE7f0ec07b545EddE332A47C2F75bbeb3'),
    KRWUSD: A<1>('0x01435677FB11763550905594A16B645847C1d0F3'),
    NGNUSD: A<1>('0x3e59bc23ea3f39e69b5e662B6fC5e7e6D22B6914'),
    PHPUSD: A<1>('0x9481e7ad8BE6BbB22A8B9F7B9fB7588d1df65DF6'),
    ZARUSD: A<1>('0x438F81D95761d7036cd2617295827D9d01Cf593f'),

    AUDUSD: A<1>('0x0000000000000000000000000000000000000000'),
    COPUSD: A<1>('0x0000000000000000000000000000000000000000'),
    BTCUSD: A<1>('0x0000000000000000000000000000000000000000'),
    SEKUSD: A<1>('0x0000000000000000000000000000000000000000'),
    SGDUSD: A<1>('0x0000000000000000000000000000000000000000'),
    SPXUSD: A<1>('0x0000000000000000000000000000000000000000'),
    XTIUSD: A<1>('0x0000000000000000000000000000000000000000'),
    XAGUSD: A<1>('0x0000000000000000000000000000000000000000'),
    BRLUSD: A<1>('0x0000000000000000000000000000000000000000'),
    BTCBUSD: A<1>('0x0000000000000000000000000000000000000000'),
  },
  42: {
    EURUSD: A<42>('0x0c15Ab9A0DB086e062194c273CC79f41597Bbf13'),
    GBPUSD: A<42>('0x28b0061f44E6A9780224AA61BEc8C3Fcb0d37de9'),
    CHFUSD: A<42>('0xed0616BeF04D374969f302a34AE4A63882490A8C'),
    XAUUSD: A<42>('0xc8fb5684f2707C82f28595dEaC017Bfdf44EE9c5'),
    ETHUSD: A<42>('0x9326BFA02ADD2366b30bacB125260Af641031331'),
    JPYUSD: A<42>('0xD627B1eF3AC23F1d3e576FA6206126F3c1Bd0942'),
    KRWUSD: A<42>('0x9e465c5499023675051517E9Ee5f4C334D91e369'),

    // FAKE Address
    CADUSD: A<42>('0x0000000000000000000000000000000000000000'),
    NGNUSD: A<42>('0x0000000000000000000000000000000000000000'),
    PHPUSD: A<42>('0x0000000000000000000000000000000000000000'),
    ZARUSD: A<42>('0x0000000000000000000000000000000000000000'),
    AUDUSD: A<42>('0x0000000000000000000000000000000000000000'),
    COPUSD: A<42>('0x0000000000000000000000000000000000000000'),
    BTCUSD: A<42>('0x0000000000000000000000000000000000000000'),
    SEKUSD: A<42>('0x0000000000000000000000000000000000000000'),
    SGDUSD: A<42>('0x0000000000000000000000000000000000000000'),
    SPXUSD: A<42>('0x0000000000000000000000000000000000000000'),
    XTIUSD: A<42>('0x0000000000000000000000000000000000000000'),
    XAGUSD: A<42>('0x0000000000000000000000000000000000000000'),
    BRLUSD: A<42>('0x0000000000000000000000000000000000000000'),
    BTCBUSD: A<42>('0x0000000000000000000000000000000000000000'),
  },
  137: {
    EURUSD: A<137>('0x73366Fe0AA0Ded304479862808e02506FE556a98'),
    GBPUSD: A<137>('0x099a2540848573e94fb1Ca0Fa420b00acbBc845a'),
    CHFUSD: A<137>('0xc76f762CedF0F78a439727861628E0fdfE1e70c2'),
    XAUUSD: A<137>('0x0000000000000000000000000000000000000000'),
    CADUSD: A<137>('0xACA44ABb8B04D07D883202F99FA5E3c53ed57Fb5'),
    JPYUSD: A<137>('0xD647a6fC9BC6402301583C91decC5989d8Bc382D'),
    PHPUSD: A<137>('0x218231089Bebb2A31970c3b77E96eCfb3BA006D1'),
    AUDUSD: A<137>('0x062Df9C4efd2030e243ffCc398b652e8b8F95C6f'),
    COPUSD: A<137>('0xDe6302Dfa0ac45B2B1b1a23304469DA630b2F59B'),
    SEKUSD: A<137>('0xbd92B4919ae82be8473859295dEF0e778A626302'),
    SGDUSD: A<137>('0x8CE3cAc0E6635ce04783709ca3CC4F5fc5304299'),
    BTCUSD: A<137>('0xDE31F8bFBD8c84b5360CFACCa3539B938dd78ae6'),

    ETHUSD: A<137>('0xF9680D99D6C9589e2a93a78A04A279e509205945'),
    KRWUSD: A<137>('0x0000000000000000000000000000000000000000'),
    NGNUSD: A<137>('0x0000000000000000000000000000000000000000'),
    ZARUSD: A<137>('0x0000000000000000000000000000000000000000'),
    SPXUSD: A<137>('0x0000000000000000000000000000000000000000'),
    XTIUSD: A<137>('0x0000000000000000000000000000000000000000'),
    XAGUSD: A<137>('0x0000000000000000000000000000000000000000'),
    BRLUSD: A<137>('0x0000000000000000000000000000000000000000'),
    BTCBUSD: A<137>('0x0000000000000000000000000000000000000000'),
  },
  80001: {
    EURUSD: A<80001>('0x876e7aa32a6f71405bd3ba5151cc6a43d15bffe6'),
    GBPUSD: A<80001>('0x6f94eed129e6e29b19951e5b6f40c025d2348cf2'),
    CHFUSD: A<80001>('0x1d5cbe59b8166d35eaa309045c5dd34b453eb4f3'),
    XAUUSD: A<80001>('0xddb827c1b6b29c02532739a53d226a57381e719c'),
    ETHUSD: A<80001>('0x0715A7794a1dc8e42615F059dD6e406A6594651A'),

    JPYUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    KRWUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    CADUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    NGNUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    PHPUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    ZARUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    AUDUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    COPUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    BTCUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    SEKUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    SGDUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    XTIUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    XAGUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    SPXUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    BRLUSD: A<80001>('0x0000000000000000000000000000000000000000'),
    BTCBUSD: A<80001>('0x0000000000000000000000000000000000000000'),
  },
  56: {
    EURUSD: A<56>('0x0bf79F617988C472DcA68ff41eFe1338955b9A80'),
    GBPUSD: A<56>('0x8FAf16F710003E538189334541F5D4a391Da46a0'),
    CHFUSD: A<56>('0x964261740356cB4aaD0C3D2003Ce808A4176a46d'),
    NGNUSD: A<56>('0x1FF2B48ed0A1669d6CcC83f4B3c84FDdF13Ea594'),
    ZARUSD: A<56>('0xDE1952A1bF53f8E558cc761ad2564884E55B2c6F'),
    BRLUSD: A<56>('0x5cb1Cb3eA5FB46de1CE1D0F3BaDB3212e8d8eF48'),
    BTCUSD: A<56>('0x264990fbd0A4796A3E3d8E37C4d5F87a3aCa5Ebf'),
    BTCBUSD: A<56>('0x7130d2a12b9bcbfae4f2634d864a1ee1ce3ead9c'),

    XAUUSD: A<56>('0x0000000000000000000000000000000000000000'),
    ETHUSD: A<56>('0x0000000000000000000000000000000000000000'),

    JPYUSD: A<56>('0x0000000000000000000000000000000000000000'),
    KRWUSD: A<56>('0x0000000000000000000000000000000000000000'),
    CADUSD: A<56>('0x0000000000000000000000000000000000000000'),
    PHPUSD: A<56>('0x0000000000000000000000000000000000000000'),
    AUDUSD: A<56>('0x0000000000000000000000000000000000000000'),
    COPUSD: A<56>('0x0000000000000000000000000000000000000000'),
    SEKUSD: A<56>('0x0000000000000000000000000000000000000000'),
    SGDUSD: A<56>('0x0000000000000000000000000000000000000000'),
    XTIUSD: A<56>('0x0000000000000000000000000000000000000000'),
    XAGUSD: A<56>('0x0000000000000000000000000000000000000000'),
    SPXUSD: A<56>('0x0000000000000000000000000000000000000000'),
  },
} as const);

export const burnerWalletConfig = typeCheck<BurnerTokens>()({
  WBTC: {
    name: 'BTC',
    symbol: 'WBTC',
    nonceFN: 'getNonce',
    // chainLinkFeedIdentifier: 'BTCUSD',
    network: {
      80001: A<80001>('0xe6b8a5cf854791412c1f6efc7caf629f5df1c747'),
      1: A<1>('0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'),
      42: A<42>('0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'),
      137: A<137>('0x1bfd67037b42cf73acf2047067bd4f2c47d9bfd6'),
      56: A<56>('0x7130d2A12B9BCbFAe4f2634d864A1Ee1Ce3Ead9c'),
    },
  },
});
export type BurnerWalletExtraTokens = keyof typeof burnerWalletConfig;
export const burnerWalletSynthereumConfig = {
  137: {
    chainlink: chainlinkAggregators[137],
    poolRegistry: A<137>('0xdCE12741DF9d2CcF2A8bB611684C8151De91a7d2'),
    perVersionConfig: [
      {
        poolVersion: 'v4',
        extraTokens: {
          WBTC: {
            name: 'BTC',
            symbol: 'WBTC',
            nonceFN: 'getNonce',
            // chainLinkFeedIdentifier: 'BTCUSD',
            network: {
              80001: A<80001>('0xe6b8a5cf854791412c1f6efc7caf629f5df1c747'),
              1: A<1>('0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'),
              42: A<42>('0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'),
              137: A<137>('0x1bfd67037b42cf73acf2047067bd4f2c47d9bfd6'),
            },
          },
        },
      },
    ],
  },
  56: {
    chainlink: chainlinkAggregators[56],
    poolRegistry: A<56>('0x930A54D8Af945F6D1BED5AAF63b63fAb50a8197f'),
    perVersionConfig: [
      {
        poolVersion: 'v5',
        extraTokens: {
          WBTC: {
            name: 'BTC',
            symbol: 'WBTC',
            nonceFN: 'getNonce',
            // chainLinkFeedIdentifier: 'BTCUSD',
            network: {
              56: A<56>('0x7130d2A12B9BCbFAe4f2634d864A1Ee1Ce3Ead9c'),
            },
          },
        },
      },
    ],
  },
};
